#!/bin/sh
# PCP QA Test No. 1231
# Test that pmlogrewrite(1) updates help text records when InDoms change
#
# Copyright (c) 2018 Red Hat.  All Rights Reserved.
#

seq=`basename $0`
echo "QA output created by $seq"

# get standard environment, filters and checks
. ./common.product
. ./common.filter
. ./common.check

# test for-some-thing || _notrun No support for some-thing

_cleanup()
{
    cd $here
    $sudo rm -rf $tmp $tmp.*
}

status=1	# failure is the default!
$sudo rm -rf $tmp $tmp.* $seq.full
trap "_cleanup; exit \$status" 0 1 2 3 15

_filter()
{
    tmpx=`echo $tmp`
    sed -e 's/^Archive:.* Host:/ARCHIVE: Host:/' \
	-e "s|$tmpx|TMP|g" \
	-e 's|PID for pmlogger: [0-9]*|PID for pmlogger: PID|'
}

# real QA test starts here
DIR=archives

# First, run pmlogrewrite against the archive, changing indom 2.1 to 2.200
CONFIG=$tmp.config
cat > $CONFIG << EOF
INDOM 2.1 { INDOM -> 2.200 }
EOF
echo contents of $CONFIG >> $seq.full
echo ........................ >> $seq.full
cat $CONFIG >> $seq.full
echo ........................ >> $seq.full
IN=$DIR/20180127.08.40
OUT=$tmp.pmlogrewrite
rm -f $OUT.*
echo "Running pmlogrewrite -c $CONFIG $IN $OUT" | _filter | tee -a $seq.full
pmlogrewrite -c $CONFIG $IN $OUT 2>&1 >> $seq.full
[ $? -eq 0 ] || echo "Error running pmlogrewrite -c $CONFIG $IN $OUT -- see $seq.full"

# Now run pmdumplog against the original and extracted archives.
DUMP1=$tmp.original.txt
echo "Running pmdumplog -zhide $IN" | _filter | tee -a $seq.full
pmdumplog -zhide $IN 2>&1 > $DUMP1

DUMP2=$tmp.extracted.txt
IN=$OUT
echo "Running pmdumplog -zhide $IN" | _filter | tee -a $seq.full
pmdumplog -zhide $IN 2>&1 > $DUMP2

# Make sure the indom has been updated in the help text records
echo "Running diff $DUMP1 $DUMP2" | _filter | tee -a $seq.full
diff $DUMP1 $DUMP2 2>&1 | _filter | tee -a $seq.full

# Now, run pmlogrewrite against the archive, changing indom 2.1 to 200.1
CONFIG=$tmp.config
cat > $CONFIG << EOF
INDOM 2.1 { INDOM -> 200.1 }
EOF
echo contents of $CONFIG >> $seq.full
echo ........................ >> $seq.full
cat $CONFIG >> $seq.full
echo ........................ >> $seq.full
IN=$DIR/20180127.08.40
OUT=$tmp.pmlogrewrite
rm -f $OUT.*
echo "Running pmlogrewrite -c $CONFIG $IN $OUT" | _filter | tee -a $seq.full
pmlogrewrite -c $CONFIG $IN $OUT 2>&1 >> $seq.full
[ $? -eq 0 ] || echo "Error running pmlogrewrite -c $CONFIG $IN $OUT -- see $seq.full"
pmlogextract $OUT $tmp.xxxx
# Now run pmdumplog against the original and extracted archives.
DUMP1=$tmp.original.txt
echo "Running pmdumplog -zhide $IN" | _filter | tee -a $seq.full
pmdumplog -zhide $IN 2>&1 > $DUMP1

DUMP2=$tmp.extracted.txt
IN=$OUT
echo "Running pmdumplog -zhide $IN" | _filter | tee -a $seq.full
pmdumplog -zhide $IN 2>&1 > $DUMP2

# Make sure the imdom has been updated in the help text records
echo "Running diff $DUMP1 $DUMP2" | _filter | tee -a $seq.full
diff $DUMP1 $DUMP2 2>&1 | _filter | tee -a $seq.full

# success, all done
status=0
exit
